﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
#endregion

namespace LD27
{
    public class BackgroundObject : Orbital
    {
        public BackgroundObject(Level level, string textureName, float scale)
            : base(level, false, scale)
        {
            TextureName = textureName;

            AddToComponents();
        }

        public string TextureName { get; private set; }

        Texture2D _texture;

        protected override void LoadContent()
        {
            base.LoadContent();

            _texture = Game.Content.Load<Texture2D>(TextureName);

            Size = new Vector2(_texture.Width, _texture.Height);

            _spriteBatch = new SpriteBatch(GraphicsDevice);
        }

        public override void Initialize()
        {
            base.Initialize();
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);

        }

        SpriteBatch _spriteBatch;

        public override void Draw(GameTime gameTime)
        {
            base.Draw(gameTime);

            _spriteBatch.Begin(SpriteSortMode.Deferred,
                BlendState.AlphaBlend,
                SamplerState.PointWrap,
                DepthStencilState.None, RasterizerState.CullCounterClockwise, null);


            _spriteBatch.Draw(_texture, ViewportPosition, null, Color.White, 0, Vector2.Zero, Scale,
                SpriteEffects.None, 0);

            _spriteBatch.End();
        }



    }
}
