﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Audio;
#endregion

namespace LD27
{
    public class Enemy : Destructable
    {
        public Enemy(Level level)
            : base(level, "ShipExplosion", "ShipExplosionSound", 1)
        {
            CalculateOrbitAngle = true;

            AddToComponents();
        }

        GeneratedTexture _texture;

        protected override void LoadContent()
        {
            base.LoadContent();

            _texture = EnemyTextureGenerator.Generate(Level);

            Size = _texture.Size;
        }

        public override void Initialize()
        {
            base.Initialize();
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);

        }

        public override void Draw(GameTime gameTime)
        {
            base.Draw(gameTime);


            _texture.Position = ViewportPosition;
            _texture.RotationAngle = RotationAngle;
            _texture.RotationOrigin = RotationOrigin;
            _texture.Scale = Scale;

            _texture.Draw();

        }
    }
}
