﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Audio;
#endregion

namespace LD27
{
    public class GeneratedTexture
    {
        public GeneratedTexture(GraphicsDevice device)
        {
            _spriteBatch = new SpriteBatch(device);
        }

        List<GeneratedTexturePart> _parts = new List<GeneratedTexturePart>();

        public void AddPart(GeneratedTexturePart part)
        {
            part.Parent = this;
            _parts.Add(part);
        }


        SpriteBatch _spriteBatch;

        public void Update(GameTime gameTime)
        {

        }

        public Vector2 Size { get; set; }

        public Vector2 Position { get; set; }
        public Vector2 RotationOrigin { get; set; }
        public float RotationAngle { get; set; }
        public float Scale { get; set; }


        public void Draw()
        {

            _spriteBatch.Begin(SpriteSortMode.Deferred,
                BlendState.AlphaBlend,
                SamplerState.PointWrap,
                DepthStencilState.None, RasterizerState.CullCounterClockwise, null);


            foreach (var part in _parts)
            {
                part.RotationAngle = RotationAngle;
                part.RotationOrigin = RotationOrigin;
                part.Draw(_spriteBatch);
            }

            _spriteBatch.End();
        }

    }
}
