﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Audio;
#endregion

namespace LD27
{
    public class GeneratedTexturePart
    {
        public GeneratedTexturePart(GraphicsDevice device, Texture2D texture, int frameWidth, int frameIndex,
            bool flipVertically, bool flipHorizontally)
        {
            Texture = texture;
            FrameWidth = frameWidth;
            FlipVertically = flipVertically;
            FlipHorizontally = flipHorizontally;


            Scale = 1;

            if (texture.Width % frameWidth != 0)
                throw new Exception();
        }

        public bool FlipVertically { get; set; }
        public bool FlipHorizontally { get; set; }
        
        public TimeSpan FrameDisplayDuration { get; private set; }

        TimeSpan _lastFrameChangeTime;

        public void Update(GameTime gameTime)
        {

        }

        public GeneratedTexture Parent { get; set; }

        public Vector2 Position { get; set; }
        public Vector2 RotationOrigin { get; set; }
        public float RotationAngle { get; set; }
        public float Scale { get; set; }

        public void Draw(SpriteBatch spriteBatch)
        {
            var effects = SpriteEffects.None;

            if (FlipHorizontally)
                effects |= SpriteEffects.FlipHorizontally;

            if (FlipVertically)
                effects |= SpriteEffects.FlipVertically;

            spriteBatch.Draw(Texture, Parent.Position + Position - RotationOrigin,
                new Rectangle(FrameIndex * FrameWidth, 0, FrameWidth, Texture.Height),
                Color.White, RotationAngle, RotationOrigin, Scale,
                effects, 0);
        }


        public int FrameIndex { get; set; }

        public Texture2D Texture { get; private set; }
        public int FrameWidth { get; private set; }
    }
}
