﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using System.Collections;
#endregion

namespace LD27
{
    public class Level1 : Level
    {
        public Level1(Game game)
            : base(game)
        {
        }


        protected override void OnLoadLevel()
        {
            var viewportWidth = GraphicsDevice.Viewport.Width;
            var viewportHeight = GraphicsDevice.Viewport.Height;


            SecondsToCollect.Add(1);
            SecondsToCollect.Add(2);
            SecondsToCollect.Add(3);

            float r;

            for (int i = 0; i < 500; i++)
            {
                var x = Random.Next(0, 30);
                var scale = 1 + 1f / (x == 0 ? 1 : x);
                var stone = new BackgroundObject(this, "Waste", scale);
                stone.VelocityPolar = new Vector2(0, -5);

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                stone.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            for (int i = 0; i < 50; i++)
            {
                var x = Random.Next(0, 50);
                var scale = 1 + 1f / (x == 0 ? 1 : x);
                var asteroid = new Asteroid(this, i % 2 == 0 ? "SpaceWaste1" : "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound",
                    scale);
                asteroid.VelocityPolar = new Vector2(0, 5);

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                asteroid.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            for (int i = 0; i < 50; i++)
            {
                var enemy = new Guard(this, "Guard1");
                enemy.VelocityPolar = new Vector2(0, 6);
                enemy.ShotStrenght = 2;
                enemy.BulletCount = 2;

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                enemy.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            foreach (var sn in SecondsToCollect)
            {
                for (int i = 0; i < 3; i++)
                {
                    var second = new Second(this, sn);
                    second.VelocityPolar = new Vector2(0, 6);

                    r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                    second.PositionPolar =
                        new Vector2(r, Random.Next(0, 360));
                }
            }

            var b = new Boss(this, "Boss1");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 2;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            b.PositionPolar =
                new Vector2(r, 300);


            b = new Boss(this, "Boss1");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 2;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 140);


            b = new Boss(this, "Boss1");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 2;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 200);



            var a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 5);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            a.PositionPolar =
                new Vector2(r, 340);



            a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            a.PositionPolar =
                new Vector2(Radius - viewportWidth / 2, 200);

            a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            a.PositionPolar =
                new Vector2(Radius + viewportWidth / 2, 200);




            a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            a.PositionPolar =
                new Vector2(r, 90);


            a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            a.PositionPolar =
                new Vector2(r, 0);


            a = new Asteroid(this, "Asteroid", "AsteroidExplosion", "AsteroidExplosionSound", 10);
            a.VelocityPolar = new Vector2(0, 0);

            a.PositionPolar =
                new Vector2(Radius, 160);

        }
    }
}
