﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using System.Collections;
#endregion

namespace LD27
{
    public class Level2 : Level
    {
        public Level2(Game game)
            : base(game)
        {
        }

        protected override void OnLoadLevel()
        {
            var viewportWidth = GraphicsDevice.Viewport.Width;
            var viewportHeight = GraphicsDevice.Viewport.Height;

            SecondsToCollect.Add(4);
            SecondsToCollect.Add(5);
            SecondsToCollect.Add(6);

            float r;

            for (int i = 0; i < 500; i++)
            {
                var x = Random.Next(0, 30);
                var scale = 1 + 1f / (x == 0 ? 1 : x);
                var stone = new BackgroundObject(this, "Waste", scale);
                stone.VelocityPolar = new Vector2(0, -5);

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                stone.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            for (int i = 0; i < 70; i++)
            {
                var n = Random.Next(1, 5);
                var x = Random.Next(0, 50);
                var scale = 1 + 1f / (x == 0 ? 1 : x);
                var asteroid = new Asteroid(this, "SpaceWaste" + n, "Explosion", "AsteroidExplosionSound",
                    scale);
                asteroid.VelocityPolar = new Vector2(0, 5);

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                asteroid.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            for (int i = 0; i < 50; i++)
            {
                var enemy = new Guard(this, "Guard2");
                enemy.VelocityPolar = new Vector2(0, 6);
                enemy.ShotStrenght = 3;
                enemy.BulletCount = 4;

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                enemy.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            foreach (var sn in SecondsToCollect)
            {
                for (int i = 0; i < 3; i++)
                {
                    var second = new Second(this, sn);
                    second.VelocityPolar = new Vector2(0, 6);

                    r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                    second.PositionPolar =
                        new Vector2(r, Random.Next(0, 360));
                }
            }


            var b = new Boss(this, "Boss2");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 4;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            b.PositionPolar =
                new Vector2(r, 350);


            b = new Boss(this, "Boss2");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 4;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 140);


            b = new Boss(this, "Boss2");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 4;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 200);


            var a = new Asteroid(this, "SpaceWaste1", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 70);

            a = new Asteroid(this, "SpaceWaste2", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);


            a = new Asteroid(this, "SpaceWaste3", "Explosion", "AsteroidExplosionSound", 9);
            a.VelocityPolar = new Vector2(0, 0);
            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 10);

            a = new Asteroid(this, "SpaceWaste4", "Explosion", "AsteroidExplosionSound", 3);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 210);

            a = new Asteroid(this, "SpaceWaste3", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);


            a = new Asteroid(this, "SpaceWaste4", "Explosion", "AsteroidExplosionSound", 2);
            a.VelocityPolar = new Vector2(0, 0);
            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 200);

        }
    }
}
