﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using System.Collections;
#endregion

namespace LD27
{
    public class Level3 : Level
    {
        public Level3(Game game)
            : base(game)
        {
        }

        protected override void OnLoadLevel()
        {
            var viewportWidth = GraphicsDevice.Viewport.Width;
            var viewportHeight = GraphicsDevice.Viewport.Height;

            SecondsToCollect.Add(7);
            SecondsToCollect.Add(8);
            SecondsToCollect.Add(9);

            float r;

            for (int i = 0; i < 500; i++)
            {
                var x = Random.Next(0, 30);
                var scale = 1 + 1f / (x == 0 ? 1 : x);
                var stone = new BackgroundObject(this, "Stone", scale);
                stone.VelocityPolar = new Vector2(0, -5);

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                stone.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            for (int i = 0; i < 150; i++)
            {
                var n = Random.Next(1, 4);
                var enemy = new Guard(this, "Guard" + (n + 2));
                enemy.VelocityPolar = new Vector2(0, 6);
                enemy.ShotStrenght = 3;
                enemy.BulletCount = n / 2;

                r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                enemy.PositionPolar =
                    new Vector2(r, Random.Next(0, 360));
            }

            foreach (var sn in SecondsToCollect)
            {
                for (int i = 0; i < 3; i++)
                {
                    var second = new Second(this, sn);
                    second.VelocityPolar = new Vector2(0, 6);

                    r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
                    second.PositionPolar =
                        new Vector2(r, Random.Next(0, 360));
                }
            }


            var b = new Boss(this, "Boss3");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 6;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);
            b.PositionPolar =
                new Vector2(r, 300);


            b = new Boss(this, "Boss3");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 6;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 140);


            b = new Boss(this, "Boss3");
            b.VelocityPolar = new Vector2(0, 0);
            b.ShotStrenght = 4;
            b.BulletCount = 6;

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            b.PositionPolar =
                new Vector2(r, 200);


            var a = new Asteroid(this, "SpaceWaste1", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 70);

            a = new Asteroid(this, "SpaceWaste2", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);


            a = new Asteroid(this, "SpaceWaste3", "Explosion", "AsteroidExplosionSound", 9);
            a.VelocityPolar = new Vector2(0, 0);
            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 10);

            a = new Asteroid(this, "SpaceWaste4", "Explosion", "AsteroidExplosionSound", 3);
            a.VelocityPolar = new Vector2(0, 0);

            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 210);

            a = new Asteroid(this, "SpaceWaste3", "Explosion", "AsteroidExplosionSound", 7);
            a.VelocityPolar = new Vector2(0, 0);


            a = new Asteroid(this, "SpaceWaste4", "Explosion", "AsteroidExplosionSound", 2);
            a.VelocityPolar = new Vector2(0, 0);
            r = Random.Next(Radius - viewportWidth / 2, Radius + viewportWidth / 2);

            a.PositionPolar =
                new Vector2(r, 200);

        }
    }
}
