﻿#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.GamerServices;
using System.Collections;
#endregion

namespace LD27
{
    public class TextScreen : DrawableGameComponent
    {
        public TextScreen(Game game, string text, Color color)
            : base(game)
        {
            Text = text;
            Color = color;
            Scale = 5;
        }

        public string Text { get; set; }

        public float Scale { get; set; }

        public Color Color { get; set; }

        public override void Initialize()
        {
            base.Initialize();

            _previousKeyState = Keyboard.GetState();
        }

        protected override void LoadContent()
        {
            base.LoadContent();

            _spriteBatch = new SpriteBatch(GraphicsDevice);

            _monoFont = Game.Content.Load<SpriteFont>("MonoFont");
        }



        SpriteBatch _spriteBatch;

        SpriteFont _monoFont;

        public bool IsFinished { get; private set; }


        KeyboardState _previousKeyState;

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);


            if (_previousKeyState.GetPressedKeys().Length == 0 &&
                Keyboard.GetState().GetPressedKeys().Length > 0)
                IsFinished = true;

            _previousKeyState = Keyboard.GetState();

        }


        public override void Draw(GameTime gameTime)
        {
            _spriteBatch.Begin(SpriteSortMode.Immediate,
                BlendState.AlphaBlend,
                SamplerState.PointClamp,
                DepthStencilState.None, RasterizerState.CullCounterClockwise, null);

            var size = _monoFont.MeasureString(Text) * Scale;

            _spriteBatch.DrawString(_monoFont, Text,
                new Vector2((GraphicsDevice.Viewport.Width - size.X) / 2,
                    (GraphicsDevice.Viewport.Height - size.Y) / 2),
                Color, 0, Vector2.Zero, Scale, SpriteEffects.None, 0);

            _spriteBatch.End();

            
            base.Draw(gameTime);
        }
    }
}
